<?php
/**
 * Classe para gerao de grficos de barras
 */
final class TBarChart extends TChart
{
    private $data;
    private $xlabels;
    private $ylabel;
    
    /**
     * Mtodo construtor
     * @param $chartDesigner objeto TChartDesigner
     */
    public function __construct(TChartDesigner $chartDesigner)
    {
        parent::__construct($chartDesigner);
        
        $this->data = array();
    }
    
    /**
     * Define os rtulos do eixo X do grfico
     * @param $labels vetor com rtulos
     */
    public function setXLabels($labels)
    {
        $this->xlabels = $labels;
    }
    
    /**
     * Define o rtulo do eixo Y do grfico
     * @param $label rtulo
     */
    public function setYLabel($label)
    {
        $this->ylabel = $label;
    }
    
    /**
     * Adiciona uma srie de dados ao grfico
     * @param $legend legenda para a srie de dados
     * @param $data srie de dados
     */
    public function addData($legend, $data)
    {
        $this->data[$legend] = $data;
    }
    
    /**
     * Gera o grfico
     */
    public function generate()
    {
        $this->chartDesigner->drawBarChart($this->title, $this->data, $this->xlabels, $this->ylabel, 
                                           $this->width, $this->height, $this->outputPath);
    }
}
?>