<?php
/**
 * Classe abstrata para grfico
 */
abstract class TChart
{
    protected $title;
    protected $chartDesigner;
    protected $outputPath;
    protected $width;
    protected $height;
    
    /**
     * Mtodo construtor
     * @param $chartDesigner objeto TChartDesigner
     */
    public function __construct(TChartDesigner $chartDesigner)
    {
        $this->chartDesigner = $chartDesigner;
    }
    
    /**
     * Define o ttulo do grfico
     * @param $title ttulo do grfico
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }
    
    /**
     * Define o tamanho do grfico
     * @param $width  largura
     * @param $height altura
     */
    public function setSize($width, $height)
    {
        $this->width  = $width;
        $this->height = $height;
    }
    
    /**
     * Define o arquivo de sada do grfico
     * @param $outputPath localizao do arquivo de sada
     */
    public function setOutputPath($outputPath)
    {
        $this->outputPath = $outputPath;
    }
    
    /**
     * Mtodo abstrato para gerao do grfico
     */
    abstract public function generate();
}
?>